#!/bin/sh
# Copyright (c) 2000-2018 Synology Inc. All rights reserved.

WARNING_TITLE="Package Update Information"
WARNING_DESC="All services running on the high-availability cluster will be temporarily suspended during the package update, which could take up to 10 minutes depending on the number of running services."
WARNING_CHECKBOX_DESC="I would like to continue with the update"

jsWarning="[{
			\"step_title\": \"${WARNING_TITLE}\",
			\"invalid_next_disabled\": true,
			\"items\": [{
				\"type\": \"multiselect\",
				\"desc\": \"${WARNING_DESC}\",
				\"subitems\": [{
				\"desc\": \"${WARNING_CHECKBOX_DESC}\",
					\"validator\": {
						\"fn\": \"{return true === arguments[0];}\"
					}
				}]
			}]
		}]"

if [ "yes" = "$(/usr/syno/sbin/synohacore --is_ha_running)" ]; then
	/bin/echo "${jsWarning}" > ${SYNOPKG_TEMP_LOGFILE}
fi

exit 0
