#!/bin/bash

HA_PREFIX="/var/packages/HighAvailability/target"
#shellcheck source-path=SCRIPTDIR source=rc.subr
. $HA_PREFIX/etc/rc.subr

check_only_one_synonetd_process()
{
	for _ in $(seq 1 1 3); do
		#shellcheck disable=2009
		if [ 1 -ne "$(ps axw | grep -v grep | grep -c synonetd)" ]; then
			return 1
		fi
		sleep 1
	done
	return 0
}

wait_network_event_handle_done()
{
	retryLimit=${1:-30}
	if ! wait_for "check_only_one_synonetd_process" "$retryLimit"; then
		synoha_log "Error: wait for check_only_one_synonetd_process() timeout"
		return 1
	fi
	return 0
}

action=$1; shift
case "$action" in
	wait-network-event-handle-done)
		retryLimit=$1
		wait_network_event_handle_done "$retryLimit"
		;;
esac

exit $?
