synohaSyncBase = {
	rsyncBinary = "/usr/bin/rsync",
	rsyncPassWordFile = "/usr/syno/etc/packages/HighAvailability/confsync/rsync.pw",
	rsyncPort = "874",
	rsync_errcode = {
		[  0] = "ok",		-- success
		[  1] = "drop",		-- syntax or usage error
		[  2] = "drop",		-- protocol incompatibility
		[  3] = "retry",	-- errors selecting input/output files, dirs
		[  4] = "drop",		-- requested action not supported
		[  5] = "retry",	-- error starting client-server protocol (target path do not exist)
		[  6] = "retry",	-- deamon unable to append to log-file

		[ 10] = "retry",	-- error in socket IO
		[ 11] = "retry",	-- error in file IO
		[ 12] = "retry",	-- error in rsync protocol data stream
		[ 13] = "retry",	-- error with program diagnostics
		[ 14] = "retry",	-- error in IPC code
		[ 15] = "retry",	-- sibling crashed
		[ 16] = "retry",	-- sibling terminated abnormally

		[ 19] = "retry",	-- status returned when sent SIGUSR1
		[ 20] = "retry",	-- status returned when sent SIGINT, SIGTERM, SIGHUP
		[ 21] = "retry",	-- some error returned by waitpid()
		[ 22] = "retry",	-- error allocating core memory buffers
		[ 23] = "ok",		-- partial transfers are ok, since Lsyncd has registered the event that
		[ 24] = "ok",		-- caused the transfer to be partial and will recall rsync.
		[ 25] = "drop",		--  skipped some deletes due to --max-delete
		[ 30] = "retry",	-- timeout in data send/receive
		[ 35] = "retry",	-- timeout waiting for daemon connection
		-----
		--synology error code
		[ 40] = "retry",	-- system error
		[ 41] = "retry",	-- no space on remote server
		[ 42] = "wait",		-- connection failed, Fix BUG #1309
		[ 43] = "wait",		-- rsync service is no running
		[ 44] = "drop",		-- wrong password
		[ 45] = "drop",		-- file path too long
		[ 46] = "drop",		-- file path too long
		[ 47] = "drop",		-- the system can't find the netbackup module in the remote machine
		[ 48] = "drop",		-- the remote machine doesn't support the option
		[ 49] = "drop",		-- remote machine has not supported ssh or ssh service hasn't been enable
		[ 50] = "drop",		-- IP is denied by remote machine
		[ 51] = "drop",		-- Unrecongized customized command
		[ 52] = "drop",		-- service of user is disabled
		[ 53] = "drop",		-- user don't have permision to the share
		[ 54] = "drop",		-- user quota is exceeded
		[255] = "retry",	-- command failed
	},
	supportXA = function()
		local f = assert(io.popen("/bin/get_key_value /etc.defaults/synoinfo.conf support_xa" , 'r'))
		local firstLine = "no"
		local value = f:read('*l')
		if value ~= nil then
			firstLine = value
		end
		f:close()

		return ("yes" == firstLine)
	end,
}
