#!/bin/sh

if ! synohacore --is_ha_running > /dev/null; then
	exit 0
fi

if [ "Passive" = "$(/usr/local/bin/synoha --local-role)" ]; then
	exit 0
fi

if ! /usr/local/bin/synoha --remote-status | cut -d':' -f2 | grep -e online -e warning_online > /dev/null; then
    exit 0
fi

target_disks="";
space_path=$1
IFS="," read -a disks <<< $2
for disk in "${disks[@]}"
do
	if ! /usr/local/bin/synohaspacecheck --size_with_space "${disk}" "${space_path}"; then
		target_disk=$(/usr/local/bin/synohaspace --get_ui_name "${disk}")
		if [ -z "$target_disks" ]; then
			target_disks=$target_disk
		else
			target_disks="$target_disks, $target_disk"
		fi
	fi
done

if [ "" = "$target_disks" ]; then
	exit 0
fi

remote_hostname=$(/usr/local/bin/synoha --remote-name)
echo "${remote_hostname} | ${target_disks}"
exit 1
