#!/bin/sh
# Copyright (c) 2000-2017 Synology Inc. All rights reserved.

HAISRUNNING=$(synogetkeyvalue /etc/synoinfo.conf runha)

if [ "yes" != "$HAISRUNNING" ]; then
        exit 0
fi

OUTPUT_DIR="$1"

# output directory is missing
if [ -z "${OUTPUT_DIR}" ]; then
	return
fi
mkdir -p "${OUTPUT_DIR}"

SYNOHA=/var/packages/HighAvailability/target/sbin/synoha
if $SYNOHA --local-role | grep -q "Active"; then
        $SYNOHA --collect-remote-debug-log "${OUTPUT_DIR}/passive_debug.dat"
fi

cat /proc/drbd > "${OUTPUT_DIR}/proc.drbd"
crm_mon -1 > "${OUTPUT_DIR}/crm.status"
crm configure show > "${OUTPUT_DIR}/crm.configure"
cp /usr/syno/etc/packages/HighAvailability/drbd.d/global_common.conf "${OUTPUT_DIR}"
cp /usr/syno/etc/packages/HighAvailability/corosync/corosync.conf "${OUTPUT_DIR}"
mkdir -p "${OUTPUT_DIR}/drbd.d"
cp /usr/syno/etc/packages/HighAvailability/drbd.d/*.res "${OUTPUT_DIR}/drbd.d"
cp /usr/syno/etc/packages/HighAvailability/ha.conf "${OUTPUT_DIR}"
cp /usr/syno/etc/packages/HighAvailability/serv.mon.conf "${OUTPUT_DIR}"
cp -r /var/lib/ha/* "${OUTPUT_DIR}"
if [ "$($SYNOHA --status)" != "empty_passive" ] && $SYNOHA --remote-status | grep "online"; then
        # No need to collect remote logs if it is online
        rm -rf "${OUTPUT_DIR}"/remote_logs
fi
ls -l /tmp/ha > "${OUTPUT_DIR}/tmp.ha.ls"
corosync-cfgtool -s > "${OUTPUT_DIR}/corosync-cfgtool"
corosync-cpgtool > "${OUTPUT_DIR}/corosync-cpgtool"
corosync-objctl > "${OUTPUT_DIR}/corosync-objctl"

exit 0
